/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
	"fmt"
)

// ContactIncludeRelation the model 'ContactIncludeRelation'
type ContactIncludeRelation string

// List of ContactIncludeRelation
const (
	ContactIncludeRelationOrganization ContactIncludeRelation = "Organization"
	ContactIncludeRelationSegments ContactIncludeRelation = "Segments"
	ContactIncludeRelationComChannels ContactIncludeRelation = "ComChannels"
	ContactIncludeRelationPlatformComChannels ContactIncludeRelation = "PlatformComChannels"
	ContactIncludeRelationCoupons ContactIncludeRelation = "Coupons"
)

// All allowed values of ContactIncludeRelation enum
var AllowedContactIncludeRelationEnumValues = []ContactIncludeRelation{
	"Organization",
	"Segments",
	"ComChannels",
	"PlatformComChannels",
	"Coupons",
}

func (v *ContactIncludeRelation) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := ContactIncludeRelation(value)
	for _, existing := range AllowedContactIncludeRelationEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid ContactIncludeRelation", value)
}

// NewContactIncludeRelationFromValue returns a pointer to a valid ContactIncludeRelation
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewContactIncludeRelationFromValue(v string) (*ContactIncludeRelation, error) {
	ev := ContactIncludeRelation(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for ContactIncludeRelation: valid values are %v", v, AllowedContactIncludeRelationEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v ContactIncludeRelation) IsValid() bool {
	for _, existing := range AllowedContactIncludeRelationEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to ContactIncludeRelation value
func (v ContactIncludeRelation) Ptr() *ContactIncludeRelation {
	return &v
}

type NullableContactIncludeRelation struct {
	value *ContactIncludeRelation
	isSet bool
}

func (v NullableContactIncludeRelation) Get() *ContactIncludeRelation {
	return v.value
}

func (v *NullableContactIncludeRelation) Set(val *ContactIncludeRelation) {
	v.value = val
	v.isSet = true
}

func (v NullableContactIncludeRelation) IsSet() bool {
	return v.isSet
}

func (v *NullableContactIncludeRelation) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableContactIncludeRelation(val *ContactIncludeRelation) *NullableContactIncludeRelation {
	return &NullableContactIncludeRelation{value: val, isSet: true}
}

func (v NullableContactIncludeRelation) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableContactIncludeRelation) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

